commit 8c47f14b0efacdf58259cd40d797066b17d156fc
Author: Thomas Schöpping <tschoepp@cit-ec.uni-bielefeld.de>
Date:   Mon Feb 4 17:29:34 2019 +0100

    Changed all header guards so they will not use unserscores as pre- and postfix.

diff --git a/amiro-lld.h b/amiro-lld.h
index db45d1c..b903a40 100644
--- a/amiro-lld.h
+++ b/amiro-lld.h
@@ -16,8 +16,8 @@ You should have received a copy of the GNU Lesser General Public License
 along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
 
-#ifndef _AMIROLLD_H_
-#define _AMIROLLD_H_
+#ifndef AMIROLLD_H
+#define AMIROLLD_H
 
 /**
  * @brief   AMIRO-LLD identification macro.
@@ -82,4 +82,4 @@ along with this program.  If not, see <http://www.gnu.org/licenses/>.
 #error "incompatible periphAL implementation"
 #endif
 
-#endif /* _AMIROLLD_H_ */
+#endif /* AMIROLLD_H */
diff --git a/include/alld_a3906.h b/include/alld_a3906.h
index 809a2ba..899ad72 100644
--- a/include/alld_a3906.h
+++ b/include/alld_a3906.h
@@ -24,8 +24,8 @@ along with this program.  If not, see <http://www.gnu.org/licenses/>.
  * @{
  */
 
-#ifndef _AMIROLLD_A3906_H_
-#define _AMIROLLD_A3906_H_
+#ifndef AMIROLLD_A3906_H
+#define AMIROLLD_A3906_H
 
 #include <amiro-lld.h>
 
@@ -64,6 +64,6 @@ extern "C" {
 
 #endif /* defined(AMIROLLD_CFG_USE_A3906) */
 
-#endif /* _AMIROLLD_A3906_H_ */
+#endif /* AMIROLLD_A3906_H */
 
 /** @} */
diff --git a/include/alld_at24c01bn-sh-b.h b/include/alld_at24c01bn-sh-b.h
index 5b502d3..849917e 100644
--- a/include/alld_at24c01bn-sh-b.h
+++ b/include/alld_at24c01bn-sh-b.h
@@ -24,8 +24,8 @@ along with this program.  If not, see <http://www.gnu.org/licenses/>.
  * @{
  */
 
-#ifndef _AMIROLLD_AT24C01BN_H_
-#define _AMIROLLD_AT24C01BN_H_
+#ifndef AMIROLLD_AT24C01BN_H
+#define AMIROLLD_AT24C01BN_H
 
 #include <amiro-lld.h>
 
@@ -95,6 +95,6 @@ extern "C" {
 
 #endif /* defined(AMIROLLD_CFG_USE_AT24C01BN) */
 
-#endif /* _AMIROLLD_AT24C01BN_H_ */
+#endif /* AMIROLLD_AT24C01BN_H */
 
 /** @} */
diff --git a/include/alld_at42qt1050.h b/include/alld_at42qt1050.h
index e9a652e..c2314e4 100644
--- a/include/alld_at42qt1050.h
+++ b/include/alld_at42qt1050.h
@@ -24,8 +24,8 @@ along with this program.  If not, see <http://www.gnu.org/licenses/>.
  * @{
  */
 
-#ifndef _AMIROLLD_AT42QT1050_H_
-#define _AMIROLLD_AT42QT1050_H_
+#ifndef AMIROLLD_AT42QT1050_H
+#define AMIROLLD_AT42QT1050_H
 
 #include <amiro-lld.h>
 
@@ -229,6 +229,6 @@ extern "C" {
 
 #endif /* defined(AMIROLLD_CFG_USE_AT42QT1050) */
 
-#endif /* _AMIROLLD_AT42QT1050_H_ */
+#endif /* AMIROLLD_AT42QT1050_H */
 
 /** @} */
diff --git a/include/alld_bq24103a.h b/include/alld_bq24103a.h
index d57910d..a48b160 100644
--- a/include/alld_bq24103a.h
+++ b/include/alld_bq24103a.h
@@ -24,8 +24,8 @@ along with this program.  If not, see <http://www.gnu.org/licenses/>.
  * @{
  */
 
-#ifndef _AMIROLLD_BQ24103A_H_
-#define _AMIROLLD_BQ24103A_H_
+#ifndef AMIROLLD_BQ24103A_H
+#define AMIROLLD_BQ24103A_H
 
 #include <amiro-lld.h>
 
@@ -78,5 +78,7 @@ extern "C" {
 
 #endif /* defined(AMIROLLD_CFG_USE_BQ24103A) */
 
+#endif /* AMIROLLD_BQ24103A_H */
+
 /** @} */
-#endif /* _AMIROLLD_BQ24103A_H_ */
+
diff --git a/include/alld_bq27500.h b/include/alld_bq27500.h
index 7de4f4f..6a30988 100644
--- a/include/alld_bq27500.h
+++ b/include/alld_bq27500.h
@@ -24,8 +24,8 @@ along with this program.  If not, see <http://www.gnu.org/licenses/>.
  * @{
  */
 
-#ifndef _AMIROLLD_BQ27500_H_
-#define _AMIROLLD_BQ27500_H_
+#ifndef AMIROLLD_BQ27500_H
+#define AMIROLLD_BQ27500_H
 
 #include <amiro-lld.h>
 
@@ -246,6 +246,6 @@ extern "C" {
 
 #endif /* defined(AMIROLLD_CFG_USE_BQ27500) */
 
-#endif /* _AMIROLLD_BQ27500_H_ */
+#endif /* AMIROLLD_BQ27500_H */
 
 /** @} */
diff --git a/include/alld_dw1000.h b/include/alld_dw1000.h
index 4861fc6..8745cf2 100755
--- a/include/alld_dw1000.h
+++ b/include/alld_dw1000.h
@@ -28,10 +28,11 @@ along with this program.  If not, see <http://www.gnu.org/licenses/>.
  *
  */
 
-#ifndef __AMIROLLD_DW1000_H__
-#define __AMIROLLD_DW1000_H__
+#ifndef AMIROLLD_DW1000_H
+#define AMIROLLD_DW1000_H
 
 #include <amiro-lld.h>
+
 #if defined(AMIROLLD_CFG_USE_DW1000) || defined(__DOXYGEN__)
 
 
@@ -1831,4 +1832,4 @@ uint32_t portGetTickCnt(void);
 
 #endif /* defined(AMIROLLD_CFG_USE_DW1000) */
 
-#endif //__AMIROLLD_DW1000_H__
+#endif /* AMIROLLD_DW1000_H */
diff --git a/include/alld_hmc5883l.h b/include/alld_hmc5883l.h
index 763f599..1ffa171 100644
--- a/include/alld_hmc5883l.h
+++ b/include/alld_hmc5883l.h
@@ -24,8 +24,8 @@ along with this program.  If not, see <http://www.gnu.org/licenses/>.
  * @{
  */
 
-#ifndef _AMIROLLD_HMC5883L_H_
-#define _AMIROLLD_HMC5883L_H_
+#ifndef AMIROLLD_HMC5883L_H
+#define AMIROLLD_HMC5883L_H
 
 #include <amiro-lld.h>
 
@@ -191,6 +191,6 @@ extern "C" {
 
 #endif /* defined(AMIROLLD_CFG_USE_HMC5883L) */
 
-#endif /* _AMIROLLD_HMC5883L_H_ */
+#endif /* AMIROLLD_HMC5883L_H */
 
 /** @} */
diff --git a/include/alld_ina219.h b/include/alld_ina219.h
index 72c913e..6321807 100644
--- a/include/alld_ina219.h
+++ b/include/alld_ina219.h
@@ -24,8 +24,8 @@ along with this program.  If not, see <http://www.gnu.org/licenses/>.
  * @{
  */
 
-#ifndef _AMIROLLD_INA219_H_
-#define _AMIROLLD_INA219_H_
+#ifndef AMIROLLD_INA219_H
+#define AMIROLLD_INA219_H
 
 #include <amiro-lld.h>
 
@@ -174,6 +174,6 @@ extern "C" {
 
 #endif /* defined(AMIROLLD_CFG_USE_INA219) */
 
-#endif /* _AMIROLLD_INA219_H_ */
+#endif /* AMIROLLD_INA219_H */
 
 /** @} */
diff --git a/include/alld_l3g4200d.h b/include/alld_l3g4200d.h
index cfbfdb3..74d95d5 100644
--- a/include/alld_l3g4200d.h
+++ b/include/alld_l3g4200d.h
@@ -24,8 +24,8 @@ along with this program.  If not, see <http://www.gnu.org/licenses/>.
  * @{
  */
 
-#ifndef _AMIROLLD_L3G4200D_H_
-#define _AMIROLLD_L3G4200D_H_
+#ifndef AMIROLLD_L3G4200D_H
+#define AMIROLLD_L3G4200D_H
 
 #include <amiro-lld.h>
 
@@ -321,6 +321,6 @@ extern "C" {
 
 #endif /* defined(AMIROLLD_CFG_USE_L3G4200D) */
 
-#endif /* _AMIROLLD_L3G4200D_H_ */
+#endif /* AMIROLLD_L3G4200D_H */
 
 /** @} */
diff --git a/include/alld_led.h b/include/alld_led.h
index 93f9716..6c8bb6d 100644
--- a/include/alld_led.h
+++ b/include/alld_led.h
@@ -24,8 +24,8 @@ along with this program.  If not, see <http://www.gnu.org/licenses/>.
  * @{
  */
 
-#ifndef _AMIROLLD_LED_H_
-#define _AMIROLLD_LED_H_
+#ifndef AMIROLLD_LED_H
+#define AMIROLLD_LED_H
 
 #include <amiro-lld.h>
 
@@ -63,6 +63,6 @@ extern "C" {
 
 #endif /* defined(AMIROLLD_CFG_USE_LED) */
 
-#endif /* _AMIROLLD_LED_H_ */
+#endif /* AMIROLLD_LED_H */
 
 /** @} */
diff --git a/include/alld_lis331dlh.h b/include/alld_lis331dlh.h
index 64f7e3b..28ccc2d 100644
--- a/include/alld_lis331dlh.h
+++ b/include/alld_lis331dlh.h
@@ -24,8 +24,8 @@ along with this program.  If not, see <http://www.gnu.org/licenses/>.
  * @{
  */
 
-#ifndef _AMIROLLD_LIS331DLH_H_
-#define _AMIROLLD_LIS331DLH_H_
+#ifndef AMIROLLD_LIS331DLH_H
+#define AMIROLLD_LIS331DLH_H
 
 #include <amiro-lld.h>
 
@@ -261,6 +261,6 @@ extern "C" {
 
 #endif /* defined(AMIROLLD_CFG_USE_LIS331DLH) */
 
-#endif /* _AMIROLLD_LIS331DLH_H_ */
+#endif /* AMIROLLD_LIS331DLH_H */
 
 /** @} */
diff --git a/include/alld_ltc4412.h b/include/alld_ltc4412.h
index 59fa72b..cdcaee2 100644
--- a/include/alld_ltc4412.h
+++ b/include/alld_ltc4412.h
@@ -24,8 +24,8 @@ along with this program.  If not, see <http://www.gnu.org/licenses/>.
  * @{
  */
 
-#ifndef _AMIROLLD_LTC4412_H_
-#define _AMIROLLD_LTC4412_H_
+#ifndef AMIROLLD_LTC4412_H
+#define AMIROLLD_LTC4412_H
 
 #include <amiro-lld.h>
 
@@ -71,6 +71,6 @@ extern "C" {
 
 #endif /* defined(AMIROLLD_CFG_USE_LTC4412) */
 
-#endif /* _AMIROLLD_LTC4412_H_ */
+#endif /* AMIROLLD_LTC4412_H */
 
 /** @} */
diff --git a/include/alld_mpr121.h b/include/alld_mpr121.h
index 58f3216..1991c54 100644
--- a/include/alld_mpr121.h
+++ b/include/alld_mpr121.h
@@ -24,8 +24,8 @@ along with this program.  If not, see <http://www.gnu.org/licenses/>.
  * @{
  */
 
-#ifndef _AMIROLLD_MPR121_H_
-#define _AMIROLLD_MPR121_H_
+#ifndef AMIROLLD_MPR121_H
+#define AMIROLLD_MPR121_H
 
 #include <amiro-lld.h>
 
@@ -226,6 +226,6 @@ extern "C" {
 
 #endif /* defined(AMIROLLD_CFG_USE_MPR121) */
 
-#endif /* _AMIROLLD_MPR121_H_ */
+#endif /* AMIROLLD_MPR121_H */
 
 /** @} */
diff --git a/include/alld_pca9544a.h b/include/alld_pca9544a.h
index ddb7ffb..b8e9619 100644
--- a/include/alld_pca9544a.h
+++ b/include/alld_pca9544a.h
@@ -24,8 +24,8 @@ along with this program.  If not, see <http://www.gnu.org/licenses/>.
  * @{
  */
 
-#ifndef _AMIROLLD_PCA9544A_H_
-#define _AMIROLLD_PCA9544A_H_
+#ifndef AMIROLLD_PCA9544A_H
+#define AMIROLLD_PCA9544A_H
 
 #include <amiro-lld.h>
 
@@ -108,6 +108,6 @@ extern "C" {
 
 #endif /* defined(AMIROLLD_CFG_USE_PCA9544A) */
 
-#endif /* _AMIROLLD_PCA9544A_H_ */
+#endif /* AMIROLLD_PCA9544A_H */
 
 /** @} */
diff --git a/include/alld_pcal6524.h b/include/alld_pcal6524.h
index 0296290..a7ccce3 100644
--- a/include/alld_pcal6524.h
+++ b/include/alld_pcal6524.h
@@ -24,8 +24,8 @@ along with this program.  If not, see <http://www.gnu.org/licenses/>.
  * @{
  */
 
-#ifndef _AMIROLLD_PCAL6524_H_
-#define _AMIROLLD_PCAL6524_H_
+#ifndef AMIROLLD_PCAL6524_H
+#define AMIROLLD_PCAL6524_H
 
 #include <amiro-lld.h>
 
@@ -338,6 +338,6 @@ extern "C" {
 
 #endif /* defined(AMIROLLD_CFG_USE_PCAL6524) */
 
-#endif /* _AMIROLLD_PCAL6524_H_ */
+#endif /* AMIROLLD_PCAL6524_H */
 
 /** @} */
diff --git a/include/alld_pklcs1212e4001.h b/include/alld_pklcs1212e4001.h
index 62c39a6..f768111 100644
--- a/include/alld_pklcs1212e4001.h
+++ b/include/alld_pklcs1212e4001.h
@@ -24,8 +24,8 @@ along with this program.  If not, see <http://www.gnu.org/licenses/>.
  * @{
  */
 
-#ifndef _AMIROLLD_PKLCS1212E4001_H_
-#define _AMIROLLD_PKLCS1212E4001_H_
+#ifndef AMIROLLD_PKLCS1212E4001_H
+#define AMIROLLD_PKLCS1212E4001_H
 
 #include <amiro-lld.h>
 
@@ -57,6 +57,6 @@ extern "C" {
 
 #endif /* defined(AMIROLLD_CFG_USE_PKLCS1212E4001) */
 
-#endif /* _AMIROLLD_PKLCS1212E4001_H_ */
+#endif /* AMIROLLD_PKLCS1212E4001_H */
 
 /** @} */
diff --git a/include/alld_tlc5947.h b/include/alld_tlc5947.h
index 5af53f8..0f9287b 100644
--- a/include/alld_tlc5947.h
+++ b/include/alld_tlc5947.h
@@ -24,8 +24,8 @@ along with this program.  If not, see <http://www.gnu.org/licenses/>.
  * @{
  */
 
-#ifndef _AMIROLLD_TLC5947_H_
-#define _AMIROLLD_TLC5947_H_
+#ifndef AMIROLLD_TLC5947_H
+#define AMIROLLD_TLC5947_H
 
 #include <amiro-lld.h>
 
@@ -96,6 +96,6 @@ extern "C" {
 
 #endif /* defined(AMIROLLD_CFG_USE_TLC5947) */
 
-#endif /* _AMIROLLD_TLC5947_H_ */
+#endif /* AMIROLLD_TLC5947_H */
 
 /** @} */
diff --git a/include/alld_tps2051bdbv.h b/include/alld_tps2051bdbv.h
index fa8fe39..36a314f 100644
--- a/include/alld_tps2051bdbv.h
+++ b/include/alld_tps2051bdbv.h
@@ -24,8 +24,8 @@ along with this program.  If not, see <http://www.gnu.org/licenses/>.
  * @{
  */
 
-#ifndef _AMIROLLD_TPS2051B_H_
-#define _AMIROLLD_TPS2051B_H_
+#ifndef AMIROLLD_TPS2051B_H
+#define AMIROLLD_TPS2051B_H
 
 #include <amiro-lld.h>
 
@@ -77,6 +77,6 @@ extern "C" {
 
 #endif /* defined(AMIROLLD_CFG_USE_TPS2051BDBV) */
 
-#endif /* _AMIROLLD_TPS2051B_H_ */
+#endif /* AMIROLLD_TPS2051B_H */
 
 /** @} */
diff --git a/include/alld_tps62113.h b/include/alld_tps62113.h
index b0b55c6..3fb3fd9 100644
--- a/include/alld_tps62113.h
+++ b/include/alld_tps62113.h
@@ -24,8 +24,8 @@ along with this program.  If not, see <http://www.gnu.org/licenses/>.
  * @{
  */
 
-#ifndef _AMIROLLD_TPS62113_H_
-#define _AMIROLLD_TPS62113_H_
+#ifndef AMIROLLD_TPS62113_H
+#define AMIROLLD_TPS62113_H
 
 #include <amiro-lld.h>
 
@@ -62,6 +62,6 @@ extern "C" {
 
 #endif /* defined(AMIROLLD_CFG_USE_TPS62113) */
 
-#endif /* _AMIROLLD_TPS62113_H_ */
+#endif /* AMIROLLD_TPS62113_H */
 
 /** @} */
diff --git a/include/alld_vcnl4020.h b/include/alld_vcnl4020.h
index 8213aab..80c506f 100644
--- a/include/alld_vcnl4020.h
+++ b/include/alld_vcnl4020.h
@@ -24,8 +24,8 @@ along with this program.  If not, see <http://www.gnu.org/licenses/>.
  * @{
  */
 
-#ifndef _AMIROLLD_VCNL4020_H_
-#define _AMIROLLD_VCNL4020_H_
+#ifndef AMIROLLD_VCNL4020_H
+#define AMIROLLD_VCNL4020_H
 
 #include <amiro-lld.h>
 
@@ -245,6 +245,6 @@ extern "C" {
 
 #endif /* defined(AMIROLLD_CFG_USE_VCNL4020) */
 
-#endif /* _AMIROLLD_VCNL4020_H_ */
+#endif /* AMIROLLD_VCNL4020_H */
 
 /** @} */
diff --git a/include/deca_instance.h b/include/deca_instance.h
index 78b856e..0ab5562 100755
--- a/include/deca_instance.h
+++ b/include/deca_instance.h
@@ -10,17 +10,19 @@
  *
  * @author DecaWave
  */
-#ifndef _DECAINSTANCE_H_
-#define _DECAINSTANCE_H_
-
-#ifdef __cplusplus
-extern "C" {
-#endif
+#ifndef DECAINSTANCE_H
+#define DECAINSTANCE_H
 
 #include <amiro-lld.h>
+
 #if defined(AMIROLLD_CFG_USE_DW1000) || defined(__DOXYGEN__)
+
 #include <alld_dw1000.h>
 
+#ifdef __cplusplus
+extern "C" {
+#endif
+
 /******************************************************************************************************************
 ********************* NOTES on TREK compile/build time features/options ***********************************************************
 *******************************************************************************************************************/
@@ -650,5 +652,7 @@ instance_data_t* instance_get_local_structure_ptr(unsigned int x);
 #ifdef __cplusplus
 }
 #endif
+
 #endif /* defined(AMIROLLD_CFG_USE_DW1000) */
-#endif  //__DECAINSTANCE_H__
+
+#endif /* DECAINSTANCE_H */
diff --git a/periphALtypes.h b/periphALtypes.h
index 2e02d5f..2d360ff 100644
--- a/periphALtypes.h
+++ b/periphALtypes.h
@@ -16,8 +16,8 @@ You should have received a copy of the GNU Lesser General Public License
 along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
 
-#ifndef _AMIROLLD_PERIPHALTYPES_H_
-#define _AMIROLLD_PERIPHALTYPES_H_
+#ifndef AMIROLLD_PERIPHALTYPES_H
+#define AMIROLLD_PERIPHALTYPES_H
 
 /*============================================================================*/
 /* DEPENDENCIES                                                               */
@@ -206,4 +206,4 @@ typedef uint16_t apalI2Caddr_t;
 /*============================================================================*/
 
 
-#endif /* _AMIROLLD_PERIPHALTYPES_H_ */
+#endif /* AMIROLLD_PERIPHALTYPES_H */
diff --git a/templates/alldconf.h b/templates/alldconf.h
index a857b31..62eaf3a 100644
--- a/templates/alldconf.h
+++ b/templates/alldconf.h
@@ -16,8 +16,8 @@ You should have received a copy of the GNU Lesser General Public License
 along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
 
-#ifndef _ALLDCONF_H_
-#define _ALLDCONF_H_
+#ifndef ALLDCONF_H
+#define ALLDCONF_H
 
 /*
  * compatibility guards
@@ -42,4 +42,4 @@ along with this program.  If not, see <http://www.gnu.org/licenses/>.
  */
 #define AMIROLLD_CFG_USE_<driver_name>
 
-#endif /* _ALLDCONF_H_ */
+#endif /* ALLDCONF_H */
diff --git a/templates/periphAL.h b/templates/periphAL.h
index e6af021..60d7c0e 100644
--- a/templates/periphAL.h
+++ b/templates/periphAL.h
@@ -16,8 +16,8 @@ You should have received a copy of the GNU Lesser General Public License
 along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
 
-#ifndef _AMIROLLD_PERIPHAL_H_
-#define _AMIROLLD_PERIPHAL_H_
+#ifndef AMIROLLD_PERIPHAL_H
+#define AMIROLLD_PERIPHAL_H
 
 /*============================================================================*/
 /* VERSION                                                                    */
@@ -354,4 +354,5 @@ void apalDbgPrintf(fmt, ...);
 }
 #endif
 
-#endif /* _AMIROOS_PERIPHAL_H_ */
+#endif /* AMIROOS_PERIPHAL_H */
+