commit 3ed0cc4da52b1c40be56b3f32ea893e7e9e6d904
Author: Thomas Schöpping <tschoepp@cit-ec.uni-bielefeld.de>
Date:   Wed Jul 29 11:02:08 2020 +0200

    VL53L1X driver overhauled.

diff --git a/drivers/VL53L1X/v1/alld_VL53L1X.h b/drivers/VL53L1X/v1/alld_VL53L1X.h
index 606f607..8e22e51 100644
--- a/drivers/VL53L1X/v1/alld_VL53L1X.h
+++ b/drivers/VL53L1X/v1/alld_VL53L1X.h
@@ -1,8 +1,26 @@
+/*
+AMiRo-LLD is a compilation of low-level hardware drivers for the Autonomous Mini Robot (AMiRo) platform.
+Copyright (C) 2016..2019  Thomas Schöpping et al.
+
+This program is free software: you can redistribute it and/or modify
+it under the terms of the GNU Lesser General Public License as published by
+the Free Software Foundation, either version 3 of the License, or
+(at your option) any later version.
+
+This program is distributed in the hope that it will be useful,
+but WITHOUT ANY WARRANTY; without even the implied warranty of
+MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+GNU Lesser General Public License for more details.
+
+You should have received a copy of the GNU Lesser General Public License
+along with this program.  If not, see <http://www.gnu.org/licenses/>.
+*/
+
 /**
  * @file    alld_VL53L1X.h
- * @brief   Touch sensor macros and structures.
+ * @brief   ToF sensor macros and structures.
  *
- * @addtogroup lld_touch
+ * @addtogroup lld_vl53l1x
  * @{
  */
 
@@ -10,19 +28,21 @@
 #define AMIROLLD_VL53L1X_H
 
 #include <amiro-lld.h>
-#include <alld_VL53L1X_types.h>
 #include <vl53l1_api.h>
+
 /******************************************************************************/
 /* CONSTANTS                                                                  */
 /******************************************************************************/
-// 400kHz
-#define VL53L1X_LLD_I2C_MAXFREQUENCY 400000
 
-/* Default I2C address */
-/* #define VL53L1X_LLD_I2C_ADDR_DEFAULT      0x52 */
-#define VL53L1X_LLD_I2C_ADDR_DEFAULT           0x29
+/**
+ * @brief   Maximum I2C frequency (in Hz).
+ */
+#define VL53L1X_LLD_I2C_MAXFREQUENCY            1000000
 
-#define VL53L1X_LLD_BOOTDURATION     1200
+/**
+ * @brief   Default I2C address.
+ */
+#define VL53L1X_LLD_I2C_ADDR_DEFAULT            0x29
 
 /******************************************************************************/
 /* SETTINGS                                                                   */
@@ -36,13 +56,20 @@
 /* DATA STRUCTURES AND TYPES                                                  */
 /******************************************************************************/
 
+/*
+ * Structures and types are declared in a separate file, because ST API requires
+ * this information, too.
+ */
+#include <vl53l1_platform_user_data.h>
+
 /**
- * @brief The state of the GPIOs.
+ * @brief   The state of the VL53L1X device.
+ * @details Represents the state of the XSHUT signal.
  */
 typedef enum {
-  GPIO_LLD_STATE_OFF = 0x00,   /**< 'on' state of the LED */
-  GPIO_LLD_STATE_ON  = 0x01,   /**< 'off' state of the LED */
-} gpio_lld_state_t;
+  VL53L1X_LLD_STATE_OFF = 0x00, /**< Device is deactivated via XSHUT signal. */
+  VL53L1X_LLD_STATE_ON  = 0x01, /**< Device is active according to XSHUT signal. */
+} vl53l1x_lld_state_t;
 
 /******************************************************************************/
 /* MACROS                                                                     */
@@ -55,18 +82,17 @@ typedef enum {
 #ifdef __cplusplus
 extern "C" {
 #endif
-  apalExitStatus_t hello_world(void);
-  apalExitStatus_t vl53l1x_GPIO1_set(const VL53L1XDriver* const vlx, const gpio_lld_state_t state);
-
+  apalExitStatus_t vl53l1x_lld_getState(VL53L1XDriver* vl53l1x, vl53l1x_lld_state_t* state);
+  apalExitStatus_t vl53l1x_lld_init(VL53L1XDriver* vl53l1x);
+  apalExitStatus_t vl53l1x_lld_reset(VL53L1XDriver* vl53l1x);
 #ifdef __cplusplus
 }
 #endif
 
-
 /******************************************************************************/
 /* INLINE FUNCTIONS                                                           */
 /******************************************************************************/
 
-
-
 #endif /* AMIROLLD_VL53L1X_H */
+
+/** @} */